---
title: "Release v0.14.0"
linkTitle: "Release v0.14.0"
date: 2021-08-16
description: >
  Release v0.14.0
---

## Changelog since v0.13.2

From this version, Piped sends its metrics to the Control-plane by default. So far, it exposes the following metrics:

- `livestatestore_kubernetes_resource_events_total`: Number of resource events received from kubernetes server.
- `livestatestore_kubernetes_api_requests_total`: Number of requests sent to kubernetes api server.
- `cloudprovider_kubernetes_tool_calls_total`: Number of calls made to run the tool like kubectl, kustomize.
- `plan_preview_command_received_total`: Total number of plan-preview commands received at piped.
- `plan_preview_command_handled_total`: Total number of plan-preview commands handled at piped.
- `plan_preview_command_handling_seconds`: Histogram of handling seconds of plan-preview commands.
- [Go stats](https://github.com/prometheus/client_golang/blob/v1.11.0/prometheus/go_collector.go#L43-L261)
- [Process stats](https://github.com/prometheus/client_golang/blob/v1.11.0/prometheus/go_collector.go#L43-L261)

### Notable Changes

* Enable to collect metrics for all components by default ([#2327](https://github.com/pipe-cd/pipecd/pull/2327))
* Enable to watch the live state of Ingress within networking.k8s.io/v1 ([#2321](https://github.com/pipe-cd/pipecd/pull/2321))

### Internal Changes
* Refactor filestore package ([#2355](https://github.com/pipe-cd/pipecd/pull/2355))
* Remove metrics arg from service manifest used to install Piped on Cloud Run ([#2353](https://github.com/pipe-cd/pipecd/pull/2353))
* Remove metrics arg from command to install Piped on google cloud vm ([#2352](https://github.com/pipe-cd/pipecd/pull/2352))
* Add install piped on ECS Fargate guide ([#2351](https://github.com/pipe-cd/pipecd/pull/2351))
* Update example queries for ADA ([#2350](https://github.com/pipe-cd/pipecd/pull/2350))
* Change Prometheus pod update strategy to Recreate ([#2349](https://github.com/pipe-cd/pipecd/pull/2349))
* Give back NotFound when live state not found ([#2344](https://github.com/pipe-cd/pipecd/pull/2344))
* Fix replicas number of canary variant in example ([#2343](https://github.com/pipe-cd/pipecd/pull/2343))
* Add example to show how to use canary patch ([#2339](https://github.com/pipe-cd/pipecd/pull/2339))
* Bump Prometheus client to v1.11.0 ([#2338](https://github.com/pipe-cd/pipecd/pull/2338))
* Add ability to patch manifests for the CANARY variant ([#2333](https://github.com/pipe-cd/pipecd/pull/2333))
* Remove unused directory ([#2336](https://github.com/pipe-cd/pipecd/pull/2336))
* Show event id when registering event succeeded ([#2334](https://github.com/pipe-cd/pipecd/pull/2334))
* Return InvalidArgument code when Piped tries to operate deleted app ([#2330](https://github.com/pipe-cd/pipecd/pull/2330))
* Remove pipecd_server prefixes from incoming request dashboard ([#2329](https://github.com/pipe-cd/pipecd/pull/2329))
* Add piped dashboard variable ([#2326](https://github.com/pipe-cd/pipecd/pull/2326))
* Ensure to register grpc server metrics to custom Prometheus registerer ([#2325](https://github.com/pipe-cd/pipecd/pull/2325))
* Make it possible to create ManagedCertificate dedicated for Grafana ([#2324](https://github.com/pipe-cd/pipecd/pull/2324))
* Change default secret name for monitoring IAP ([#2323](https://github.com/pipe-cd/pipecd/pull/2323))
* Support Google IAP for Grafana Ingress ([#2315](https://github.com/pipe-cd/pipecd/pull/2315))
* Fix wrong extension name for terraform secret management example ([#2322](https://github.com/pipe-cd/pipecd/pull/2322))
* Update adding project docs ([#2320](https://github.com/pipe-cd/pipecd/pull/2320))
* Add overview dashboard to control-plane folder ([#2319](https://github.com/pipe-cd/pipecd/pull/2319))
* Update piped dashboard reflects metrics name changed ([#2317](https://github.com/pipe-cd/pipecd/pull/2317))
* Migrate dgrijalva/jwt-go to golang-jwt/jwt ([#2304](https://github.com/pipe-cd/pipecd/pull/2304))
* Add Grafana panel to track gRPC error by code ([#2316](https://github.com/pipe-cd/pipecd/pull/2316))
* Update the size of PersistentVolume Prometheus uses ([#2314](https://github.com/pipe-cd/pipecd/pull/2314))
* Remove cache package from pkg/cli dependencies list ([#2313](https://github.com/pipe-cd/pipecd/pull/2313))
* Use labels to distinguish what component's metrics ([#2312](https://github.com/pipe-cd/pipecd/pull/2312))
* Update actions-plan-preview to use pipectl v0.13.2 ([#2311](https://github.com/pipe-cd/pipecd/pull/2311))

